Package org.springframework.web.context.request

# Interface WebRequestInterceptor

All Known Subinterfaces:
  `AsyncWebRequestInterceptor`

public interface WebRequestInterceptor
Interface for general web request interception. Allows for being applied to Servlet request by building on the `WebRequest` abstraction.

This interface assumes MVC-style request processing: A handler gets executed, exposes a set of model objects, then a view gets rendered based on that model. Alternatively, a handler may also process the request completely, with no view to be rendered.

In an async processing scenario, the handler may be executed in a separate thread while the main thread exits without rendering or invoking the `postHandle` and `afterCompletion` callbacks. When concurrent handler execution completes, the request is dispatched back in order to proceed with rendering the model and all methods of this contract are invoked again. For further options and comments see `org.springframework.web.context.request.async.AsyncWebRequestInterceptor`

This interface is deliberately minimalistic to keep the dependencies of generic request interceptors as minimal as feasible.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  - `ServletWebRequest`
  - `org.springframework.web.servlet.DispatcherServlet`
  - `org.springframework.web.servlet.handler.AbstractHandlerMapping#setInterceptors`
  - `org.springframework.web.servlet.HandlerInterceptor`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterCompletion(WebRequest request, Exception ex)`
Callback after completion of request processing, that is, after rendering the view.
`void`
`postHandle(WebRequest request, org.springframework.ui.ModelMap model)`
Intercept the execution of a request handler after its successful invocation, right before view rendering (if any).
`void`
`preHandle(WebRequest request)`
Intercept the execution of a request handler before its invocation.

## Method Details

### preHandle

void preHandle(WebRequest request) throws Exception
Intercept the execution of a request handler before its invocation.

Allows for preparing context resources (such as a Hibernate Session) and expose them as request attributes or as thread-local objects.

Parameters:
  `request` - the current web request
Throws:
  `Exception` - in case of errors

### postHandle

void postHandle(WebRequest request, @Nullable org.springframework.ui.ModelMap model) throws Exception
Intercept the execution of a request handler after its successful invocation, right before view rendering (if any).

Allows for modifying context resources after successful handler execution (for example, flushing a Hibernate Session).

Parameters:
  `request` - the current web request
  `model` - the map of model objects that will be exposed to the view (may be `null`). Can be used to analyze the exposed model and/or to add further model attributes, if desired.
Throws:
  `Exception` - in case of errors

### afterCompletion

void afterCompletion(WebRequest request, @Nullable Exception ex) throws Exception
Callback after completion of request processing, that is, after rendering the view. Will be called on any outcome of handler execution, thus allows for proper resource cleanup.

Note: Will only be called if this interceptor's `preHandle` method has successfully completed!

Parameters:
  `request` - the current web request
  `ex` - exception thrown on handler execution, if any
Throws:
  `Exception` - in case of errors